eval 'exec /opt/VRTSperl/bin/perl -I $CLUSTER_HOME/lib -Sw $0 ${1+"$@"}'
        if 0;
# %W% %G% %U% - %Q% #
#ident "@(#)VCSOR:%M% %I%"
#
# $Copyright: Copyright (c) 2011 Symantec Corporation.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
# The Licensed Software and Documentation are deemed to be commercial
# computer software as defined in FAR 12.212 and subject to restricted
# rights as defined in FAR Section 52.227-19 "Commercial Computer
# Software - Restricted Rights" and DFARS 227.7202, "Rights in
# Commercial Computer Software or Commercial Computer Software
# Documentation", as applicable, and any successor regulations. Any use,
# modification, reproduction release, performance, display or disclosure
# of the Licensed Software and Documentation by the U.S. Government
# shall be solely in accordance with the terms of this Agreement.  $
#
# Deep/Secondary/In-depth Monitoring for the Sqlnet resource.
#
# To debug this Perl script, use:
#     perl -d <this_script_name> <values_of_arguments_below_from_main.cf>
#
# Some arguments to this script are unused. Do not remove. They help in
# keeping the arguments same and consistent across all the related scripts.
# Set DBG LEVEL to 21 to get the command line outputs in the log file.
# Some arguments to this script are unused. Do not remove. They help in
# keeping the arguments same and consistent across all the related scripts.
#
my ($ResName, $Owner, $Home, $TnsAdmin, $Listener,
	        $EnvFile,$MonScript,$LsnrPwd,  $AgentDebug, $Encoding) = @ARGV;

use ag_i18n_inc;
$ResName = $ARGV[0]; shift;
VCSAG_SET_ENVS ($ResName);

#platform specific paths are set in the oraconfig.pm file
no lib ".";
use lib qw(.);
use netconfig () ;
use vars qw(%CONF);
*CONF =\%netconfig::CONF;
my $GREP=$CONF{GREP};
my $SU=$CONF{SU};
my $PASSWDGREP=$CONF{PASSWDGREP};
my $PSALRM = $CONF{PSALRM};
my $IGREP = $CONF{IGREP};
my $VGREP = $CONF{VGREP};
my $AWK = $CONF{AWK};
my $LIBRARY_PATH = $CONF{LIBRARY_PATH};

my $ENCODE = "";
my $TIMEOUT = 45;
my ($LSNRMGR) ;
#### use strict , vars variables included###
my $use_csh = 0;
my $out = "";
use netlsnrlib;
use strict;

$Home =~ s/^\s*(.*?)\s*$/$1/;
$Home =~ s/\/?$//;

if( `$PASSWDGREP $Owner` =~ m/(^|[\r\n])$Owner:[^\n\r]*\/bin\/[^\r\n]*csh([\r\n]|$)/ ) {
        $use_csh=1;
}
#
if ($AgentDebug == 1) {
	my $final_string = "";
	for (@ARGV) {
		$final_string = $final_string . "\\\"" . $_ ."\\\" ";
	}
	VCSAG_LOGDBG_MSG(4,"ARGV is: $final_string");
}

# halog will display the output from third party (in this case, Oracle)
# using the user specified encoding scheme
#
if ( $Encoding ) {
        $ENCODE = "-encoding $Encoding";
}
#
# Bail if the Oracle home directory doesn't exist
#
my $ret =netlsnrlib::check_oracle_home ($Home);
if ($ret) {

	VCSAG_LOG_MSG ("E","Oracle home directory $Home does not exist",1,$Home);
        exit $VCSAG_RES_UNKNOWN;
        # Return UNKNOWN status
}


# Set the default values if not already set.
#
$TnsAdmin = "/var/opt/oracle" unless $TnsAdmin;
$Listener = "LISTENER" unless $Listener;
my $stat_str = "$Home/bin/lsnrctl status $Listener";

$ENV{'ORACLE_HOME'} = $Home;
$ENV{'TNS_ADMIN'} = $TnsAdmin;

$ret =netlsnrlib::check_oracle_client ($Home,$LSNRMGR );
if ($ret) {
        VCSAG_LOG_MSG ( "E" ,"lsnrctl not found in $Home/bin", 4,$Home);
        exit $VCSAG_RES_UNKNOWN;               # Resource state is UNKNOWN
}
#
# Subroutine - catch_alrm
# Purpose - To kill the lsnrctl process (if any) after $TIMEOUT seconds
#
sub catch_alrm {
        if ( $AgentDebug == 1) {
                VCSAG_LOG_MSG ( "E" , "lsnrctl operation timed out",14);
        }
					
	my $current_pgid = getpgrp();
        my @pids;
        my $pid;
        @pids= `$PSALRM -g $current_pgid | $IGREP "$LSNRMGR" | $VGREP grep | $AWK '{print \$1}'`;
        foreach $pid (@pids) {
                kill (9, $pid);
        }
        exit $VCSAG_RES_UNKNOWN;
}
	
# See the comment in the "Netlsnr/online" script regarding the code below.
#
# It is the user's responsibility to ensure that EnvFile can
# be sourced successfully using the login shell of $User. 
#

my $LD_ENV = "";
my $ValidFile = "";
$LD_ENV= netlsnrlib::set_environment($use_csh,$EnvFile, $Owner,$Home,$ValidFile);

if ( $ValidFile ) {
	VCSAG_LOG_MSG ( "W"," File $EnvFile is not a valid text file ",8,$EnvFile);
}

# If the IP on which listener is listening is unplumbed or if the cable is
# pulled out, lsnrctl stop will timeout after a long time.  To avoid this
# excessive delay, lsnrctl process will be killed if it does not complete
# in $TIMEOUT seconds or less.  We set an alarm here and kill the processes
# in the signal handler catch_alrm.  Do not use "sleep" when alarm is set.
#

my $Pword="";
my $vcs_home=$VCSHOME;
$vcs_home = "/opt/VRTSvcs" if (!$vcs_home);

$SIG{ALRM}=\&catch_alrm;
alarm $TIMEOUT;

$LsnrPwd =~s/^\s+//;
$LsnrPwd =~s/\s+$//;

if ( $LsnrPwd ) {
        $Pword = `$HADECRYPT $LsnrPwd`;

        if ($? != 0) {
                VCSAG_LOG_MSG ( "W"," Encountered errors while decrypting password!",6);
                $Pword="";
        }
}

my $LsnrResult;

if ($Pword eq "" or $Pword eq " " ) {
        $LsnrResult = `$SU $Owner -c '$LD_ENV; echo $LIBRARY_PATH - \$$LIBRARY_PATH; $stat_str'`;
} else {
        $LsnrResult = `$SU $Owner -c '$LD_ENV; echo $LIBRARY_PATH - \$$LIBRARY_PATH; $LSNRMGR' <<!
set current_listener $Listener
set password $Pword
status $Listener
exit
!`;
}

# If lsnrctl stat completes within $TIMEOUT seconds or even otherwise,
# clear the alarm

if ($? != 0) {
        alarm 0;
        print $LsnrResult;
        exit $VCSAG_RES_OFFLINE ;#resource is offline
} else {
        alarm 0;
        exit $VCSAG_RES_ONLINE; # resource is online
}


