eval 'exec /opt/VRTSperl/bin/perl -I $CLUSTER_HOME/lib -Sw $0 ${1+"$@"}'
    if 0;
#
# $Copyright: Copyright (c) 2011 Symantec Corporation.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
# The Licensed Software and Documentation are deemed to be commercial
# computer software as defined in FAR 12.212 and subject to restricted
# rights as defined in FAR Section 52.227-19 "Commercial Computer
# Software - Restricted Rights" and DFARS 227.7202, "Rights in
# Commercial Computer Software or Commercial Computer Software
# Documentation", as applicable, and any successor regulations. Any use,
# modification, reproduction release, performance, display or disclosure
# of the Licensed Software and Documentation by the U.S. Government
# shall be solely in accordance with the terms of this Agreement.  $
#
#
# This script does a transaction in user specified database.
# Returns 110 on success & 100 on failure.
#

use ag_i18n_inc;
my $vcs_home = $VCSHOME;

($res_name,$Server,$Owner,$Homedir,$Version,$Sa,$Sapswd,$User,$UPword,$Db,$Table) = @ARGV;
$Sa="NOT USED";
$Sapswd="NOT USED";

#changes for UL
VCSAG_SET_ENVS ($res_name, 20018,"monitor");
$CAT = "/usr/bin/cat";
$VCS_KEY = "VCSSY:";
$CMD_KEY = "CMDSY:";

if($Homedir eq "")
{
        VCSAG_LOG_MSG("E", "Sybase home directory must be defined", 11);
	exit 100;
}

if( ! -d $Homedir) {
        VCSAG_LOG_MSG("E", "Sybase home directory '$Homedir' does not exist", 12, $Homedir);
        exit 100;
}

$ENV{'DSQUERY'} = "$Server";
$ENV{'SYBASE'} = "$Homedir";
$ENV{'PATH'} = ".:$Homedir/bin:$ENV{'PATH'}";
$ENV{'LD_LIBRARY_PATH'} ||= "";
$ENV{'LD_LIBRARY_PATH'} = "$Homedir/lib:$ENV{'LD_LIBRARY_PATH'}";

if ($UPword !~ /^$CMD_KEY/)
{
	if ($UPword =~ /^$VCS_KEY/)
	{
		@tmp_array = split($VCS_KEY, $UPword);
		$passwd_file = $tmp_array[1];
		$encrypted_passwd = `$CAT $passwd_file`;
		$encrypted_passwd =~ s/\n$// ;
	}
	else
	{
		$encrypted_passwd = $UPword;
	}
	my $password_decrypt_cmd = "$HADECRYPT $encrypted_passwd 2> /dev/null";
	$actual_passwd = `$password_decrypt_cmd` ;
	if( $? != 0 ) 
	{ 
        	$actual_passwd = $encrypted_passwd; 
        	VCSAG_LOGDBG_MSG(4, "Using password level CT001", 29); 
	} 
	else 
	{ 
        	VCSAG_LOGDBG_MSG(4, "Using password level EP001", 30); 
	} 
}
else
{
    $password_decrypt_cmd = $UPword;
    $password_decrypt_cmd =~ s/^$CMD_KEY//g;
    $actual_passwd=`su $Owner -c \'$password_decrypt_cmd\'`;
    VCSAG_LOGDBG_MSG(4, "Using password level CMD001 ", 31);
}


if ($Version =~ /1[25]/) {
        if ( ( getpwnam $Owner )[-1] =~ /csh$/ ) {
                $ISQL_CMD="su $Owner -c \' source $Homedir/SYBASE.csh; isql -S$Server -U$User \'";
        }
        else {
                $ISQL_CMD="su $Owner -c \' . $Homedir/SYBASE.sh; isql -S$Server -U$User \'";
        }
}
else {
	VCSAG_LOG_MSG("E", "Sybase Version $Version is not supported, please contact VERITAS support.", 14, $Version);
	return 100 ;
}

#
# The folowing test updates a row "tstamp" with the latest value
# of the Sybase internal function getdate()
#
# A prerequesit for this test is that a user/password/table has been
# created before enabling the script by defining the attributes
# User/UPword/Table/Db/MonScript for the Sybase resource
#
# This task can be accomplished by the folling isql statements as user sa:
#
# isql -Usa
#Password: <SApswd>
#
# 1> use master
# 2> go
#
### Create Sybase Account for test VCS attributes User & UPword
# 1> sp_addlogin vcsuser, geheim
# 2> go
# Password correctly set.
# Account unlocked.
# New login created.
# (return status = 0) 
#
### define the Database table used for the test VCS attribute "Db"
#
# 1> create database vcsdb
# 2> go
# CREATE DATABASE: allocating 1024 pages on disk 'master'
#
### prevent growing log-file for test db
#
# 1> sp_dboption vcsdb, "trunc log on chkpt", true
# 2> go
# Database option 'trunc log on chkpt' turned ON for database 'vcsdb'.
# Run the CHECKPOINT command in the database that was changed.
# (return status = 0) 
#
# 1> use vcsdb
# 2> go
#
### create table for User VCS attribute Table
# 
# 1> sp_adduser vcsuser
# 2> go
# New user added.
# (return status = 0) 
# 1> setuser "vcsuser"
# 2> go
# 1> create table vcstable (lastupd datetime)
# 2> go
#
### and add a initial value
# 1> insert into vcstable (lastupd) values (getdate())
# 2> go
# (1 row affected)
#
# To read the result you can use
# 1> select lastupd from vcstable
# 2> go
#  lastupd                    
#  -------------------------- 
#         Nov  2 1998  8:29AM 
# (1 row affected)
#
# 1> exit
#

$ISQLResult = `$ISQL_CMD <<END1
$actual_passwd
use $Db
go
update $Table set lastupd  = getdate()
go
commit
go
exit
END1`;


@lines = split(/\n+/, $ISQLResult);
$count = @lines;
for ($i=0;$i<$count;$i++)
{
	 if( $lines[$i] =~ /Msg.*Level.*State/ )
	 {
		last if $lines[$i] !~ /Msg 2401, Level 11, State 2:/;
	 }
	 if( $lines[$i] =~ /.*row.*\s+.*affected/ )
	 {
        	VCSAG_LOGDBG_MSG(2, "Output of isql:\n$ISQLResult", 23, $ISQLResult);
		exit 110;
	 }
}

VCSAG_LOGDBG_MSG(1, "Output of isql:\n$ISQLResult", 23, $ISQLResult);

exit 100;
